## libindi 1.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(libindi C CXX)

cmake_policy(SET CMP0003 NEW)
#FIXME the following requires CMake v3.0
#cmake_policy(SET CMP0042 OLD)
set(CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}")
##################  INDI version  ################################
set(INDI_SOVERSION "1")
set(CMAKE_INDI_VERSION_MAJOR 1)
set(CMAKE_INDI_VERSION_MINOR 1)
set(CMAKE_INDI_VERSION_RELEASE 0)
set(CMAKE_INDI_VERSION_STRING "${CMAKE_INDI_VERSION_MAJOR}.${CMAKE_INDI_VERSION_MINOR}.${CMAKE_INDI_VERSION_RELEASE}")

##################  Paths  ################################
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")
set(DATA_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/indi/")
set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include")

IF(APPLE)
set(CMAKE_SHARED_LINKER_FLAGS "-undefined dynamic_lookup")
ENDIF(APPLE)

##################  setup install directories  ################################
set (LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
set (LIB_DESTINATION "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
## the following are directories where stuff will be installed to
set(INCLUDE_INSTALL_DIR      "${CMAKE_INSTALL_PREFIX}/include/")
set(PKGCONFIG_INSTALL_PREFIX "${LIB_DESTINATION}/pkgconfig/")
set(UDEVRULES_INSTALL_DIR "/lib/udev/rules.d" CACHE STRING "Base directory for udev rules")

##################  Includes  ################################
Include (CheckCXXSourceCompiles)
include (MacroOptionalFindPackage)
include (MacroLogFeature)
include (MacroBoolTo01)
include (CheckIncludeFiles)

FIND_LIBRARY(M_LIB m)
FIND_PACKAGE(ZLIB REQUIRED)
FIND_PACKAGE(USB-1 REQUIRED)
find_package(CURL REQUIRED)
FIND_PACKAGE(CFITSIO REQUIRED)
FIND_PACKAGE(Nova REQUIRED)
FIND_PACKAGE(Threads REQUIRED)
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  FIND_PACKAGE(JPEG REQUIRED)
endif ()

if (NOT CFITSIO_FOUND OR CFITSIO_VERSION_MAJOR LESS 3)
  message(FATAL_ERROR "CFITSIO version too old, Please install cfitsio 3.x and try again. http://heasarc.gsfc.nasa.gov/fitsio/fitsio.html")
endif (NOT CFITSIO_FOUND OR CFITSIO_VERSION_MAJOR LESS 3)

macro_bool_to_01(CFITSIO_FOUND HAVE_CFITSIO_H)
macro_log_feature(CFITSIO_FOUND "libcfitsio" "A library for reading and writing data files in FITS (Flexible Image Transport System) data format" "http://heasarc.gsfc.nasa.gov/fitsio/fitsio.html" FALSE "3.03" "Provides INDI with FITS I/O support.")

macro_bool_to_01(NOVA_FOUND HAVE_NOVA_H)
macro_log_feature(NOVA_FOUND "libnova" "A general purpose, double precision, Celestial Mechanics, Astrometry and Astrodynamics library" "http://libnova.sourceforge.net" FALSE "0.12.1" "Provides INDI with astrodynamics library.")

check_include_files(linux/videodev2.h HAVE_LINUX_VIDEODEV2_H)
check_include_files(termios.h TERMIOS_FOUND)
macro_bool_to_01(TERMIOS_FOUND HAVE_TERMIOS_H)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h )

include_directories( ${CMAKE_CURRENT_BINARY_DIR})
include_directories( ${CMAKE_SOURCE_DIR})
include_directories( ${CMAKE_SOURCE_DIR}/libs)
include_directories( ${CMAKE_SOURCE_DIR}/libs/indibase)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
include_directories( ${CMAKE_SOURCE_DIR}/libs/webcam)
  include_directories( ${JPEG_INCLUDE_DIR} )
endif()

if (CFITSIO_FOUND)
  include_directories(${CFITSIO_INCLUDE_DIR})
endif (CFITSIO_FOUND)

include_directories(${NOVA_INCLUDE_DIR})

set(liblilxml_SRCS  ${CMAKE_SOURCE_DIR}/libs/lilxml.c )

set(libindicom_SRCS
	${CMAKE_SOURCE_DIR}/libs/indicom.c
	${CMAKE_SOURCE_DIR}/base64.c
	)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
set(libwebcam_SRCS
	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_base.cpp
	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_colorspace.c
	${CMAKE_SOURCE_DIR}/libs/webcam/ccvt_c2.c
	${CMAKE_SOURCE_DIR}/libs/webcam/ccvt_misc.c
        ${CMAKE_SOURCE_DIR}/libs/webcam/jpegutils.c
	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_decode/v4l2_decode.cpp
	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_decode/v4l2_builtin_decoder.cpp
	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_record/v4l2_record.cpp
	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_record/ser_recorder.cpp
	)
endif()

set (indimain_SRCS
        ${CMAKE_SOURCE_DIR}/indidriver.c
	${CMAKE_SOURCE_DIR}/indidrivermain.c
	${CMAKE_SOURCE_DIR}/eventloop.c
    )

set (indiclient_SRCS
        ${CMAKE_SOURCE_DIR}/libs/indibase/basedevice.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/baseclient.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indiproperty.cpp
    )

set (indidriver_SRCS
        ${CMAKE_SOURCE_DIR}/libs/indibase/basedevice.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/defaultdevice.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indiproperty.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indiccd.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/inditelescope.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indifilterwheel.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indifocuserinterface.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indifocuser.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indiusbdevice.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indiguiderinterface.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indifilterinterface.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indidomeinterface.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indidome.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indigps.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indiweather.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indilogger.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/indicontroller.cpp
    )

set (lx_SRCS
     ${CMAKE_SOURCE_DIR}/libs/lx/Lx.cpp
)

IF (APPLE)
set(hidapi_SRCS ${CMAKE_SOURCE_DIR}/libs/indibase/hid_mac.c)
ELSEIF (WIN32)
set(hidapi_SRCS ${CMAKE_SOURCE_DIR}/libs/indibase/hid_win.c)
ELSE ()
set(hidapi_SRCS ${CMAKE_SOURCE_DIR}/libs/indibase/hid_libusb.c)
ENDIF()

######################################
########### INDI SERVER ##############
######################################
set(indiserver_SRCS indiserver.c fq.c)

add_executable(indiserver ${indiserver_SRCS} ${liblilxml_SRCS})

target_link_libraries(indiserver ${CMAKE_THREAD_LIBS_INIT})

install(TARGETS indiserver RUNTIME DESTINATION bin)

#################################################
############# INDI Shared Library ###############
# To offer lilxml and communination routines    #
# Mostly used by generic clients                #
#################################################
add_library(indi SHARED ${libindicom_SRCS} ${liblilxml_SRCS})
target_link_libraries(indi ${NOVA_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY} ${CFITSIO_LIBRARIES})

install(TARGETS indi LIBRARY DESTINATION ${LIB_DESTINATION})
set_target_properties(indi PROPERTIES VERSION ${CMAKE_INDI_VERSION_STRING} SOVERSION ${INDI_SOVERSION})

##################################################
########## INDI Default Driver Library ###########
# To link with main() and indibase classes  ######
##################################################
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
add_library(indidriver SHARED ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${libwebcam_SRCS} ${hidapi_SRCS})
target_link_libraries(indidriver ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY} ${JPEG_LIBRARY})
add_library(indidriverstatic STATIC ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${libwebcam_SRCS})
target_link_libraries(indidriverstatic ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY} ${JPEG_LIBRARY})
else()
add_library(indidriver SHARED ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${hidapi_SRCS})
target_link_libraries(indidriver ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY})
add_library(indidriverstatic STATIC ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS})
target_link_libraries(indidriverstatic ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY})
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
set_target_properties(indidriver indidriverstatic PROPERTIES VERSION ${CMAKE_INDI_VERSION_STRING} SOVERSION ${INDI_SOVERSION} OUTPUT_NAME indidriver)
install(TARGETS indidriver LIBRARY DESTINATION ${LIB_DESTINATION})
install(TARGETS indidriverstatic ARCHIVE DESTINATION ${LIB_DESTINATION})

##################################################
########### INDI Client Static Library ###########
##################################################
add_library(indiclient STATIC ${indiclient_SRCS})
#-----------------------------------------------------------------------------
#
# To fix compilation problem: relocation R_X86_64_32 against `a local symbol' can not be
# used when making a shared object; recompile with -fPIC
# See http://www.cmake.org/pipermail/cmake/2007-May/014350.html
#
IF( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
  SET_TARGET_PROPERTIES(indiclient PROPERTIES COMPILE_FLAGS "-fPIC")
ENDIF( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )

target_link_libraries(indiclient indi ${CMAKE_THREAD_LIBS_INIT})
install(TARGETS indiclient ARCHIVE DESTINATION ${LIB_DESTINATION})

##################################################
########### INDI Alignment Subsystem #############
##################################################
add_subdirectory(${CMAKE_SOURCE_DIR}/libs/indibase/alignment)

#####################################
######## AGENT GROUP #########
#####################################

########### Imager ##############
set(imager_SRCS
        ${CMAKE_SOURCE_DIR}/drivers/agent/agent_imager.cpp
   )

add_executable(indi_imager_agent ${imager_SRCS})
target_link_libraries(indi_imager_agent indidriver indiclient)
install(TARGETS indi_imager_agent RUNTIME DESTINATION bin )

#################################################################################

#####################################
########## TELESCOPE GROUP ##########
#####################################

########### LX200 Basic #############
set(lx200basic_SRCS
   ${indimain_SRCS}
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200driver.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200basic.cpp )

add_executable(indi_lx200basic ${lx200basic_SRCS} ${liblilxml_SRCS} ${libindicom_SRCS})

target_link_libraries(indi_lx200basic indidriver)

install(TARGETS indi_lx200basic RUNTIME DESTINATION bin )

#################################################################################

########### LX200 Generic ###########
set(lx200generic_SRCS
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200driver.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200autostar.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200_16.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200gps.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200generic.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200classic.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200apdriver.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200gemini.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200ap.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200fs2.cpp

)

add_executable(indi_lx200generic ${lx200generic_SRCS})

target_link_libraries(indi_lx200generic indidriver)

install(TARGETS indi_lx200generic RUNTIME DESTINATION bin )

file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/make_lx200generic_symlink.cmake
"exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200classic)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200autostar)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200_16)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200gps)\n

=== examples/CMakeLists.txt ===
add_subdirectory(tutorial_one)
add_subdirectory(tutorial_two)
add_subdirectory(tutorial_three)
add_subdirectory(tutorial_four)
add_subdirectory(tutorial_five)
add_subdirectory(tutorial_six)
add_subdirectory(tutorial_seven)

=== examples/tutorial_four/CMakeLists.txt ===
########### Tutorial four ##############
add_executable(tutorial_four simpleskeleton.cpp)

target_link_libraries(tutorial_four indidriver)

=== examples/tutorial_one/CMakeLists.txt ===
########### Tutorial one ##############
add_executable(tutorial_one simpledevice.cpp)

target_link_libraries(tutorial_one indidriver)

=== examples/tutorial_six/CMakeLists.txt ===
########### Tutorial Six ##############
add_executable(tutorial_client tutorial_client.cpp)

target_link_libraries(tutorial_client indiclient)

=== libs/indibase/alignment/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules)

find_package(GSL REQUIRED)

if (GSL_FOUND)
	include_directories(${GSL_INCLUDE_DIRS})
	set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS GSL_FOUND)
	set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS} ${CMAKE_GSL_CXX_FLAGS})
endif (GSL_FOUND)

set(INDI_MATH_PLUGINS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/indi/MathPlugins")

set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS INDI_MATH_PLUGINS_DIRECTORY="${INDI_MATH_PLUGINS_DIRECTORY}")

option(ALIGNMENT_CONVEX_HULL_DEBUGGING "Alignment subsystem - additional debugging output" OFF)

if(ALIGNMENT_CONVEX_HULL_DEBUGGING)
   set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS CONVEX_HULL_DEBUGGING)
endif(ALIGNMENT_CONVEX_HULL_DEBUGGING)

option(SKYWATCHER_API_USE_INITIAL_JULIAN_DATE "Skywatcher API - use initial Julian date only" OFF)

if(SKYWATCHER_API_USE_INITIAL_JULIAN_DATE)
   set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS USE_INITIAL_JULIAN_DATE)
endif(SKYWATCHER_API_USE_INITIAL_JULIAN_DATE)

##################################################
####### INDI AlignmentDriver shared library ######
##################################################
set (AlignmentDriver_SRCS
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/AlignmentSubsystemForDrivers.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/AlignmentSubsystemForMathPlugins.h
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/BasicMathPlugin.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/BuiltInMathPlugin.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/ConvexHull.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/DriverCommon.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/InMemoryDatabase.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/MapPropertiesToInMemoryDatabase.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/MathPlugin.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/MathPluginManagement.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/TelescopeDirectionVectorSupportFunctions.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/Common.cpp
    )

add_library(AlignmentDriver SHARED ${AlignmentDriver_SRCS})
target_link_libraries(AlignmentDriver dl)
if (GSL_FOUND)
	target_link_libraries(AlignmentDriver ${GSL_LIBRARIES})
endif (GSL_FOUND)
set_target_properties(AlignmentDriver PROPERTIES VERSION ${CMAKE_INDI_VERSION_STRING} SOVERSION ${INDI_SOVERSION} OUTPUT_NAME indiAlignmentDriver)
install(TARGETS AlignmentDriver LIBRARY DESTINATION ${LIB_DESTINATION})
install(FILES AlignmentSubsystemForMathPlugins.h AlignmentSubsystemForDrivers.h BasicMathPlugin.h BuiltInMathPlugin.h
              ClientAPIForAlignmentDatabase.h ClientAPIForMathPluginManagement.h Common.h ConvexHull.h DriverCommon.h InMemoryDatabase.h MathPlugin.h
              MathPluginManagement.h SVDMathPlugin.h TelescopeDirectionVectorSupportFunctions.h MapPropertiesToInMemoryDatabase.h
        DESTINATION ${INCLUDE_INSTALL_DIR}/libindi/alignment COMPONENT Devel)

##################################################
####### INDI AlignmentClient static library ######
##################################################
set (AlignmentClient_SRCS
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/AlignmentSubsystemForClients.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/ClientAPIForAlignmentDatabase.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/ClientAPIForMathPluginManagement.cpp
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/Common.h
    )

add_library(AlignmentClient ${AlignmentClient_SRCS})
set_target_properties(AlignmentClient PROPERTIES OUTPUT_NAME indiAlignmentClient)
install(TARGETS AlignmentClient ARCHIVE DESTINATION ${LIB_DESTINATION})

##################################################
############ LoaderCLient test program ###########
##################################################
#set(LoaderClient_SRCS
#	${CMAKE_SOURCE_DIR}/libs/indibase/alignment/LoaderClient.cpp
#	${CMAKE_SOURCE_DIR}/libs/indibase/alignment/LoaderMain.cpp
#	)

#add_executable(LoaderClient ${LoaderClient_SRCS})

#target_link_libraries(LoaderClient indiclient AlignmentClient)

#install(TARGETS LoaderClient RUNTIME DESTINATION bin)

##################################################
######### MathPluginManager test program #########
##################################################
#set(MathPluginManagerClient_SRCS
#	${CMAKE_SOURCE_DIR}/libs/indibase/alignment/MathPluginManagerClient.cpp
#	${CMAKE_SOURCE_DIR}/libs/indibase/alignment/MathPluginManagerMain.cpp
#	)

#add_executable(MathPluginManagerClient ${MathPluginManagerClient_SRCS})

#target_link_libraries(MathPluginManagerClient indiclient AlignmentClient)

#install(TARGETS MathPluginManagerClient RUNTIME DESTINATION bin)

##################################################
########### Dummy math plugin example ############
##################################################
#set(DummyMathPlugin_SRCS
#	${CMAKE_SOURCE_DIR}/libs/indibase/alignment/DummyMathPlugin.cpp
#	)

#add_library(indi_Dummy_MathPlugin SHARED ${DummyMathPlugin_SRCS})

#target_link_libraries(indi_Dummy_MathPlugin indidriver)

#install(TARGETS indi_Dummy_MathPlugin LIBRARY DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY})

##################################################
################ SVD math plugin #################
##################################################
set(SVDMathPlugin_SRCS
        ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/SVDMathPlugin.cpp
	)

add_library(indi_SVD_MathPlugin SHARED ${SVDMathPlugin_SRCS})

set_property(TARGET indi_SVD_MathPlugin APPEND PROPERTY COMPILE_DEFINITIONS SVD_TRANSFORM_MATRIX)

target_link_libraries(indi_SVD_MathPlugin indidriver)

install(TARGETS indi_SVD_MathPlugin LIBRARY DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY})

##################################################
############ Skywatcher API Mount ################
##################################################
set(skywatcherAPIMount_SRCS
   ${CMAKE_SOURCE_DIR}/drivers/telescope/skywatcherAPIMount.cpp
   ${CMAKE_SOURCE_DIR}/drivers/telescope/skywatcherAPI.cpp )

add_executable(indi_skywatcherAPIMount ${skywatcherAPIMount_SRCS})
target_link_libraries(indi_skywatcherAPIMount indidriver AlignmentDriver)

install(TARGETS indi_skywatcherAPIMount RUNTIME DESTINATION bin )

=== debian/changelog ===
libindi (1.1.0-1ubuntu1) xenial; urgency=medium

  * Mark symbols as optional, when built with -O3.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 Feb 2016 14:00:02 +0100

libindi (1.1.0-1) unstable; urgency=medium

  * New upstream release (1.1.0).

 -- Maximiliano Curia <maxy@debian.org>  Mon, 18 Jan 2016 16:06:38 +0100

libindi (1.0.0-4) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev.
    (Closes: #806834)

 -- Maximiliano Curia <maxy@debian.org>  Wed, 02 Dec 2015 11:09:08 +0100

=== debian/control ===
Source: libindi
Section: misc
Priority: optional
Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>, Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 2.6~),
               debhelper (>= 9),
               libcfitsio-dev,
               libcurl4-gnutls-dev,
               libgsl-dev,
               libgsl0-dev,
               libjpeg-dev,
               libnova-dev (>= 0.14.0),
               libusb-1.0-0-dev,
               pkg-config,
               pkg-kde-tools (>= 0.12),
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://www.indilib.org/
Vcs-Git: git://anonscm.debian.org/pkg-kde/krap/libindi.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-kde/krap/libindi.git

Package: libindi1
Section: libs
Architecture: any
Depends: libindi-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: indi-bin (>= ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- client library
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the client shared library.

Package: libindidriver1
Section: libs
Architecture: any
Depends: libindi-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- driver library
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the driver shared library.

Package: libindialignmentdriver1
Section: libs
Architecture: any
Depends: libindi-plugins (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- alignment driver lib
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the alignment driver shared library.

Package: libindi-plugins
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- plugins
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains binary plugins.

Package: libindi-dev
Section: libdevel
Architecture: any
Depends: libcfitsio3-dev,
         libindi1 (= ${binary:Version}),
         libindialignmentdriver1 (= ${binary:Version}),
         libindidriver1 (= ${binary:Version}),
         libusb-1.0-0-dev,
         ${misc:Depends}
Description: Instrument-Neutral Device Interface library -- development files
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains development headers and libraries for the INDI library.

Package: libindi-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Instrument-Neutral Device Interface library -- shared data
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the data files for the INDI library.

Package: indi-bin
Architecture: any
Depends: libindi-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: INDI server, drivers and tools
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the INDI server, the drivers for the supported
 astronomical instrumentation, and other INDI tools.

Package: indi-dbg
Priority: extra
Section: debug
Architecture: any
Depends: libindi1 (= ${binary:Version}), ${misc:Depends}
Suggests: indi-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- debug symbols
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the debug symbols for the INDI library and all the
 utilities, useful to investigate problems in INDI.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ --parallel --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip --dbg-package=indi-dbg

override_dh_makeshlibs:
	dh_makeshlibs -V

=== debian/watch ===
version=3

http://sf.net/indi/libindi_([\d.]+)\.tar\.gz

## libindi 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ##################  INDI version  ################################
 set(INDI_SOVERSION "1")
 set(CMAKE_INDI_VERSION_MAJOR 1)
-set(CMAKE_INDI_VERSION_MINOR 1)
+set(CMAKE_INDI_VERSION_MINOR 2)
 set(CMAKE_INDI_VERSION_RELEASE 0)
 set(CMAKE_INDI_VERSION_STRING "${CMAKE_INDI_VERSION_MAJOR}.${CMAKE_INDI_VERSION_MINOR}.${CMAKE_INDI_VERSION_RELEASE}")
 
@@ -98,6 +98,7 @@
 	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_decode/v4l2_builtin_decoder.cpp
 	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_record/v4l2_record.cpp
 	${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_record/ser_recorder.cpp
+        ${CMAKE_SOURCE_DIR}/libs/webcam/v4l2_record/stream_recorder.cpp
 	)
 endif()
 
@@ -125,12 +126,14 @@
         ${CMAKE_SOURCE_DIR}/libs/indibase/indiusbdevice.cpp
         ${CMAKE_SOURCE_DIR}/libs/indibase/indiguiderinterface.cpp
         ${CMAKE_SOURCE_DIR}/libs/indibase/indifilterinterface.cpp
-        ${CMAKE_SOURCE_DIR}/libs/indibase/indidomeinterface.cpp
         ${CMAKE_SOURCE_DIR}/libs/indibase/indidome.cpp
         ${CMAKE_SOURCE_DIR}/libs/indibase/indigps.cpp
         ${CMAKE_SOURCE_DIR}/libs/indibase/indiweather.cpp
+        ${CMAKE_SOURCE_DIR}/libs/indibase/indidustcapinterface.cpp
+        ${CMAKE_SOURCE_DIR}/libs/indibase/indilightboxinterface.cpp
         ${CMAKE_SOURCE_DIR}/libs/indibase/indilogger.cpp
         ${CMAKE_SOURCE_DIR}/libs/indibase/indicontroller.cpp
+
     )
 
 set (lx_SRCS
@@ -162,6 +165,7 @@
 # Mostly used by generic clients                #
 #################################################
 add_library(indi SHARED ${libindicom_SRCS} ${liblilxml_SRCS})
+SET_TARGET_PROPERTIES(indi PROPERTIES COMPILE_FLAGS "-fPIC")
 target_link_libraries(indi ${NOVA_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY} ${CFITSIO_LIBRARIES})
 
 install(TARGETS indi LIBRARY DESTINATION ${LIB_DESTINATION})
@@ -173,13 +177,15 @@
 ##################################################
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 add_library(indidriver SHARED ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${libwebcam_SRCS} ${hidapi_SRCS})
+SET_TARGET_PROPERTIES(indidriver PROPERTIES COMPILE_FLAGS "-fPIC")
 target_link_libraries(indidriver ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY} ${JPEG_LIBRARY})
-add_library(indidriverstatic STATIC ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${libwebcam_SRCS})
+add_library(indidriverstatic STATIC ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${libwebcam_SRCS} ${hidapi_SRCS})
+SET_TARGET_PROPERTIES(indidriverstatic PROPERTIES COMPILE_FLAGS "-fPIC")
 target_link_libraries(indidriverstatic ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY} ${JPEG_LIBRARY})
 else()
 add_library(indidriver SHARED ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${hidapi_SRCS})
 target_link_libraries(indidriver ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY})
-add_library(indidriverstatic STATIC ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS})
+add_library(indidriverstatic STATIC ${libindicom_SRCS} ${liblilxml_SRCS} ${indimain_SRCS} ${indidriver_SRCS} ${hidapi_SRCS})
 target_link_libraries(indidriverstatic ${LIBUSB_1_LIBRARIES} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CFITSIO_LIBRARIES} ${M_LIB} ${ZLIB_LIBRARY})
 endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 set_target_properties(indidriver indidriverstatic PROPERTIES VERSION ${CMAKE_INDI_VERSION_STRING} SOVERSION ${INDI_SOVERSION} OUTPUT_NAME indidriver)
@@ -190,15 +196,7 @@
 ########### INDI Client Static Library ###########
 ##################################################
 add_library(indiclient STATIC ${indiclient_SRCS})
-#-----------------------------------------------------------------------------
-#
-# To fix compilation problem: relocation R_X86_64_32 against `a local symbol' can not be
-# used when making a shared object; recompile with -fPIC
-# See http://www.cmake.org/pipermail/cmake/2007-May/014350.html
-#
-IF( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
-  SET_TARGET_PROPERTIES(indiclient PROPERTIES COMPILE_FLAGS "-fPIC")
-ENDIF( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
+SET_TARGET_PROPERTIES(indiclient PROPERTIES COMPILE_FLAGS "-fPIC")
 
 target_link_libraries(indiclient indi ${CMAKE_THREAD_LIBS_INIT})
 install(TARGETS indiclient ARCHIVE DESTINATION ${LIB_DESTINATION})
@@ -206,7 +204,9 @@
 ##################################################
 ########### INDI Alignment Subsystem #############
 ##################################################
+if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 add_subdirectory(${CMAKE_SOURCE_DIR}/libs/indibase/alignment)
+endif()
 
 #####################################
 ######## AGENT GROUP #########
@@ -251,9 +251,11 @@
    ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200classic.cpp
    ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200apdriver.cpp
    ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200gemini.cpp
+   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200zeq25.cpp
+   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200pulsar2.cpp
    ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200ap.cpp
    ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200fs2.cpp
-
+   ${CMAKE_SOURCE_DIR}/drivers/telescope/lx200ss2000pc.cpp
 )
 
 add_executable(indi_lx200generic ${lx200generic_SRCS})
@@ -265,5 +267,3 @@
 file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/make_lx200generic_symlink.cmake
 "exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200classic)\n
 exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200autostar)\n
-exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200_16)\n
-exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink ${BIN_INSTALL_DIR}/indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200gps)\n

=== libs/indibase/alignment/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,7 @@
     )
 
 add_library(AlignmentDriver SHARED ${AlignmentDriver_SRCS})
+SET_TARGET_PROPERTIES(AlignmentDriver PROPERTIES COMPILE_FLAGS "-fPIC")
 target_link_libraries(AlignmentDriver dl)
 if (GSL_FOUND)
 	target_link_libraries(AlignmentDriver ${GSL_LIBRARIES})
@@ -64,7 +65,8 @@
         ${CMAKE_SOURCE_DIR}/libs/indibase/alignment/Common.h
     )
 
-add_library(AlignmentClient ${AlignmentClient_SRCS})
+add_library(AlignmentClient STATIC ${AlignmentClient_SRCS})
+SET_TARGET_PROPERTIES(AlignmentClient PROPERTIES COMPILE_FLAGS "-fPIC")
 set_target_properties(AlignmentClient PROPERTIES OUTPUT_NAME indiAlignmentClient)
 install(TARGETS AlignmentClient ARCHIVE DESTINATION ${LIB_DESTINATION})

=== debian/changelog ===
libindi (1.2.0-3) unstable; urgency=medium

  * Force build against libnova-dev 0.16
  * Drop libgsl0-dev build dep

 -- Maximiliano Curia <maxy@debian.org>  Thu, 27 Oct 2016 10:41:34 +0200

libindi (1.2.0-2) unstable; urgency=medium

  * Fix libcfitsio-dev -dev dependency.
    Thanks to Aurelien Jarno for the report/reminder (Closes: 841219)

 -- Maximiliano Curia <maxy@debian.org>  Tue, 18 Oct 2016 17:26:10 +0200

libindi (1.2.0-2~) unstable; urgency=medium

  * Update symbols files to make it compatible with gcc-6.
    (Closes: 811961) Thanks to Martin Michlmayr for the report.
  * Update patch: freebsd_support (Closes: 830732)
  * Update symbols files to make then compatible with kfreebsd

 -- Maximiliano Curia <maxy@debian.org>  Thu, 14 Jul 2016 15:23:08 +0200

libindi (1.2.0-1) unstable; urgency=medium

  * Fix kfreebsd-i386 symbols. (Closes: #816443) Thanks to Steven Chamberlain
    for the report.
  * New upstream release (1.2.0).
  * Update symbols files
  * Add a .gitattributes file to use dpkg-mergechangelogs
  * Bump Standards-Version to 3.9.8
  * Migrate dbg package to automatic dbgsym

 -- Maximiliano Curia <maxy@debian.org>  Tue, 26 Apr 2016 15:14:11 +0200

libindi (1.1.0-2) unstable; urgency=medium

  * Update patch freebsd_support, use system includes for the libusb.h
    header. (Closes: 816333) Thanks to Steven Chamberlain for the patch.
  * Update symbols from 1.1.0-1 buildlogs.

 -- Maximiliano Curia <maxy@debian.org>  Tue, 01 Mar 2016 11:48:22 +0100

=== debian/control ===
--- 
+++ 
@@ -8,14 +8,13 @@
                libcfitsio-dev,
                libcurl4-gnutls-dev,
                libgsl-dev,
-               libgsl0-dev,
                libjpeg-dev,
-               libnova-dev (>= 0.14.0),
+               libnova-dev (>= 0.16),
                libusb-1.0-0-dev,
                pkg-config,
                pkg-kde-tools (>= 0.12),
                zlib1g-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.indilib.org/
 Vcs-Git: git://anonscm.debian.org/pkg-kde/krap/libindi.git
 Vcs-Browser: http://anonscm.debian.org/cgit/pkg-kde/krap/libindi.git
@@ -90,7 +89,7 @@
 Package: libindi-dev
 Section: libdevel
 Architecture: any
-Depends: libcfitsio3-dev,
+Depends: libcfitsio-dev,
          libindi1 (= ${binary:Version}),
          libindialignmentdriver1 (= ${binary:Version}),
          libindidriver1 (= ${binary:Version}),
@@ -132,21 +131,3 @@
  .
  This package contains the INDI server, the drivers for the supported
  astronomical instrumentation, and other INDI tools.
-
-Package: indi-dbg
-Priority: extra
-Section: debug
-Architecture: any
-Depends: libindi1 (= ${binary:Version}), ${misc:Depends}
-Suggests: indi-bin (= ${binary:Version})
-Pre-Depends: ${misc:Pre-Depends}
-Multi-Arch: same
-Description: Instrument-Neutral Device Interface library -- debug symbols
- INDI (Instrument-Neutral Device Interface) is a distributed XML-based
- control protocol designed to operate astronomical instrumentation.
- INDI is small, flexible, easy to parse, scalable, and stateless.
- It supports common DCS functions such as remote control, data acquisition,
- monitoring, and a lot more.
- .
- This package contains the debug symbols for the INDI library and all the
- utilities, useful to investigate problems in INDI.

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)
 
 override_dh_strip:
-	dh_strip --dbg-package=indi-dbg
+	dh_strip --dbgsym-migration='indi-dbg (<= 1.2.0-1~~)'
 
 override_dh_makeshlibs:
 	dh_makeshlibs -V
